local ns = 'UX'

local wm = WINDOW_MANAGER


-- deep not supported
function UX_DuplicateControl(name, control)
	local controlType = control:GetType()

	local duplicate = wm:CreateControl(name, control:GetParent(), controlType)
	duplicate:SetHidden(control:IsHidden())

	duplicate:SetDimensions(control:GetDimensions())
	duplicate:SetAnchor( select(2, control:GetAnchor()) )

	duplicate:SetScale(control:GetScale())
	duplicate:SetAlpha(control:GetAlpha())
	duplicate:SetColor(control:GetColor())

	duplicate:SetDrawLayer(control:GetDrawLayer())
	duplicate:SetDrawLevel(control:GetDrawLevel())
	duplicate:SetDrawTier(control:GetDrawTier())

	if controlType == CT_TEXTURE then
		local texture = control:GetTextureFileName()
		if #texture ~= 0 then
			duplicate:SetTexture(texture)
		end

		duplicate:SetResizeToFitFile(control:GetResizeToFitFile())
	end

	return duplicate
end


function UX_createName(...)
	local str = table.concat({...}, '_')
	str = string.gsub(str, '[^%w_]', '_')

	local from, to = string.find(str, ns..'_')
	if from ~= 1 then
		str = ns..'_'..str
	end
	return str
end


function UX_colorize(text, ...)
	local hex = select(1, ...)

	if type(hex) ~= 'string' then
		local r, g, b = select(1, ...)

		if type(r) == 'number' and type(g) == 'number' and type(b) == 'number' then
			r = string.format('%x', math.floor(r * 255))
			if #r == 1 then r = '0'..r end

			g = string.format('%x', math.floor(g * 255))
			if #g == 1 then g = '0'..g end

			b = string.format('%x', math.floor(b * 255))
			if #b == 1 then b = '0'..b end

			hex = r..g..b
			
		else return text
		end
	end

	return string.format('|c%s%s|r', hex, text)
end